import fs from 'fs';

console.log('Start build...');

const [ MODE ] = process.argv.slice(2);
let TYPE = 'development';
const toLowerCase = str => {
    let toLower = '';
    if(typeof str == 'string') {
        toLower = str.toLowerCase();
    }
    return toLower;
}
switch( toLowerCase(MODE) ){
    case 'prod':
    case 'production':
        TYPE = 'production';
        break;
}
let environmentText = fs.readFileSync(`environment.json.template`, 'utf-8');
let environmentDevText = fs.readFileSync(`environment.dev.json`, 'utf-8');
let dockerCompose = fs.readFileSync(`docker-compose.yml.template`, 'utf-8');
let environmentDevJson = JSON.parse(environmentDevText);
let mnemonics = dockerCompose.match(/<>.+<>/gi);
if(mnemonics){
    mnemonics = new Set(mnemonics);
}
if(TYPE == 'development'){
    environmentText = environmentDevText;
    for(let mnemonic of mnemonics){
        let key = mnemonic.replace(/<>/gi, '');
        dockerCompose = dockerCompose.replace(new RegExp(mnemonic, 'gi'), environmentDevJson[key])
    }

}
fs.writeFileSync(`environment.json`, environmentText);
fs.writeFileSync(`docker-compose.yml`, dockerCompose);
console.log('Success build!');